// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// RyudoDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Ryudo.h"
#include "RyudoDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRyudoDlg _CAO

CRyudoDlg::CRyudoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRyudoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRyudoDlg)
	m_binlevel = 128;
	m_dividenum = 20;
	m_maxsize = 300;
	m_minsize = 5;
	m_color = 0;
	m_wndtouch = FALSE;
	m_result = _T("");
	m_arrange = 0;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRyudoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRyudoDlg)
	DDX_Text(pDX, IDC_BINLEVEL, m_binlevel);
	DDV_MinMaxInt(pDX, m_binlevel, 0, 255);
	DDX_Text(pDX, IDC_DIVIDENUM, m_dividenum);
	DDV_MinMaxInt(pDX, m_dividenum, 1, 99999);
	DDX_Text(pDX, IDC_MAXSIZE, m_maxsize);
	DDV_MinMaxInt(pDX, m_maxsize, 1, 999999);
	DDX_Text(pDX, IDC_MINSIZE, m_minsize);
	DDV_MinMaxInt(pDX, m_minsize, 1, 999999);
	DDX_CBIndex(pDX, IDC_COLOR, m_color);
	DDX_Check(pDX, IDC_WNDTOUCH, m_wndtouch);
	DDX_Text(pDX, IDC_RESULT, m_result);
	DDX_Radio(pDX, IDC_ARRANGE0, m_arrange);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRyudoDlg, CDialog)
	//{{AFX_MSG_MAP(CRyudoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_APPLYBINLEVEL, OnApplybinlevel)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRyudoDlg bZ[W nh

BOOL CRyudoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) );
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) );
		m_FvxImageOrg.CreateInstance( __uuidof( FvxImage ) );
		m_FvxImageBin.CreateInstance( __uuidof( FvxImage ) );
		m_FvxBlob.CreateInstance( __uuidof( FvxBlob ) );
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) );
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) );
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) );
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) );

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putye( -1 );
	
		// Rg[ނ̏
		CComboBox*    pcmb = ( CComboBox* )GetDlgItem( IDC_COLOR );
		pcmb->AddString( "BLACK" );
		pcmb->AddString( "WHITE" );
		m_color = 0;
		UpdateData(FALSE); 

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep(350);

            // GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize(m_FvxImageOrg);

			try	{

				// 捞
				m_FvxVideo->GrabSync(m_FvxImageOrg);

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImageOrg);

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

}

void CRyudoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CRyudoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CRyudoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRyudoDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
	
}

BOOL CRyudoDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CRyudoDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}

// J摜捞
void CRyudoDlg::OnGrab() 
{

	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImageOrg );

    // 捞
    m_FvxVideo->GrabSync( m_FvxImageOrg );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImageOrg );
	
}

// 摜t@CǍ
void CRyudoDlg::OnLoadimage() 
{

	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImageOrg );
		
		} catch(_com_error ) {

			long lngErr=0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜`FbN
		if (( m_FvxImageOrg->GetBitPerPixel()!=8 ) || ( m_FvxImageOrg->GetImageType ()!=imageGray )){

			MessageBox("8bitO[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImageOrg->PutBitPerPixel( 8 );
            m_FvxImageOrg->PutImageType( imageGray );
            m_FvxImageOrg->PutImageWidth( 512 );
            m_FvxImageOrg->PutImageHeight( 480 );

		}

		m_FvxDisplayEx->DrawImage( m_FvxImageOrg );

	}
	
}

// \摜̕ۑ
void CRyudoDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImageOrg );
		
		} catch(_com_error ) {

			long lngErr=0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}	
}

// Qls
void CRyudoDlg::OnApplybinlevel() 
{
    
	if (! UpdateData( TRUE )) return;

    // 臒l`FbN
    if ( m_binlevel < 0 ) {
        m_binlevel = 0;
	}
	if ( m_binlevel > 255 ) {
        m_binlevel = 255;
	}
		
    if ( m_FvxImageOrg->GetBitPerPixel() == 8 ) {
        // ChangeImage𗘗pāAOCImageQlImage
        m_FvxChangeImage->FixedLevel( m_FvxImageOrg, m_FvxImageBin, m_binlevel );
	} else {
		MessageBox("8bitZW摜ł͂܂" , "G[", MB_ICONWARNING | MB_OK);
        m_FvxImageOrg->CopyTo( m_FvxImageBin );
	}
		
    m_FvxDisplayEx->DrawImage( m_FvxImageBin );

	UpdateData( FALSE );

}

// vʃNA
void CRyudoDlg::OnClear() 
{
    m_FvxDisplayEx->DrawImage( m_FvxImageOrg );
    m_FvxDisplayEx->ClearOverlay(-1);
    m_result= "";

	UpdateData(FALSE);
}

// ͈͂̐ݒ
void CRyudoDlg::OnExeregion() 
{

    long lngOK = 0;
    double dblTemp = 0;
    
    m_FvxROI->SetRectangle( m_ExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->MakeROIDialog( m_FvxImageOrg, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI->GetCheckRectangle() == 1 )) {
        m_FvxROI->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs() ) {
            dblTemp = m_ExeRegion->Getxs();
            m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys() ) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}
		
}

// Qlvs
void CRyudoDlg::OnExecute() 
{
    
	long lngCount = 0;
	long lngErr = 0;
	double dblTime = 0;
	IFvBlobResultGroup3Ptr pBlobResultGroup(__uuidof(FvBlobResultGroup));
    long *lngSizeStep;
    long *lngBlobNum;
	CString cStr;
    int i = 0;
    int j = 0;

	// ̓`FbN
	if (! UpdateData( TRUE )) return;
    
    // ʏ
    m_FvxDisplayEx->ClearOverlay( -1 );
    
    // `FbN
	if ( m_dividenum < 2 ) {
		MessageBox("͂Qȏ̐lw肵Ă" , "G[", MB_ICONWARNING | MB_OK);
		return;
	}
	
    // őEŏʐϒl`FbN
    if ( m_minsize < 1 ) {
		MessageBox("ŏʐϒl͂Pȏ̐lݒ肵Ă" , "G[", MB_ICONWARNING | MB_OK);
		return;
	}
	if ( m_minsize >= m_maxsize ) {
		MessageBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă" , "G[", MB_ICONWARNING | MB_OK);
		return;
	}

    // n_ƏI_KvȂ̂ŁA+1ϐKv
	if( NULL != ( lngSizeStep = (long*)malloc( sizeof(long) * ( m_dividenum + 1) ))) {
		if( NULL != ( lngBlobNum = (long*)malloc( sizeof(long) * ( m_dividenum + 1) ))) {

			// ʐϕn_̌vZ
			for ( i = 0; i <= m_dividenum; i++ ) {
				lngSizeStep[i] = ( m_minsize + (m_maxsize - m_minsize) * i / (double)m_dividenum ) + 0.5;
				lngBlobNum[i] = 0;
			}

			//őEŏʐϐݒ
			m_FvxBlob->PutMinSize( m_minsize );
			m_FvxBlob->PutMaxSize( m_maxsize );
    
			// ΏېFݒ
			if (m_color == 0 ) {
				m_FvxBlob->PutColor( ( COLOR_TYPE ) 0 );
			} else {
				m_FvxBlob->PutColor( ( COLOR_TYPE ) 1 );
			}
					
			// xOiojݒ
			m_FvxBlob->PutArrange( (ARRANGE_TYPE ) m_arrange );
									
			// ͈͐ڐG
			if ( m_wndtouch == TRUE ) {
				m_FvxBlob->PutWindowTouch( ON ); // ON
			} else {
				m_FvxBlob->PutWindowTouch( OFF ); // OFF
			}
			
			// 臒l`FbN
			if ( m_binlevel < 0 )  m_binlevel = 0;
			if ( m_binlevel > 255 ) m_binlevel = 255;
				
			// Ql
			if ( m_FvxImageOrg->GetBitPerPixel() == 8 ) {
				m_FvxChangeImage->FixedLevel( m_FvxImageOrg, m_FvxImageBin, m_binlevel );
			} else if ( m_FvxImageOrg->GetBitPerPixel() == 1 ) {
				m_FvxImageOrg->CopyTo( m_FvxImageBin );
			} else {
				MessageBox("BPP=1/8ȊỎ摜͂܂" , "͉摜G[", MB_ICONWARNING | MB_OK);
				return;
			}
			m_FvxDisplayEx->DrawImage( m_FvxImageBin );
    
			// ͈͐ݒ
			m_FvxBlob->SetInspectArea( m_ExeRegion );
			// ͈͂Ԃŕ`
			m_FvxDisplayEx->PutPenColor(RGB(255, 0, 0));
			m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
    
			// ԑJn
			m_FvxPerformanceCounter->StartCount();

			try {
				// Qlvs
				m_FvxBlob->Execute( m_FvxImageBin, &lngCount );

			} catch(_com_error ) {

				// G[oĂ邩mF
				// KGetErrReport\bhgăG[ԍ擾Ă
				cStr.Format("G[ err_no = %d", lngErr );
				m_FvxBlob->GetErrReport( &lngErr );
				MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);

				free((long *)lngSizeStep);
				free((long *)lngBlobNum);

				return;
			}

			// ԑI
			m_FvxPerformanceCounter->StopCount( &dblTime );
			m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
			// ʂ̎擾
			m_FvxBlob->GetResult( 0, pBlobResultGroup );
    
			//dS_ƊOڒ``悵܂
			m_FvxDisplayEx->DrawData( 0, pBlobResultGroup );
    
			for ( i = 0; i < pBlobResultGroup->GetCount(); i++ ) {
				// blobǂ̖ʐϔ͈͂ɑĂ邩ׁA̐L^܂
				for ( int j = 0; j < m_dividenum; j++ ) {
				  if ( (lngSizeStep[j] <= pBlobResultGroup->Item2(i)->Getarea()) &&  (pBlobResultGroup->Item2(i)->Getarea() < lngSizeStep[j + 1])) {
					   lngBlobNum[j] = lngBlobNum[j] + 1;
					}
				}
			}
        
			// ʂeLXg{bNXɕ\܂
			m_result.Format(" : %.2fms\r\no : %d\r\n\r\nʐϔ͈           \r\n",dblTime,lngCount);

			for ( j = 0; j < m_dividenum ; j++ ) {
				cStr.Format("%6d ` %6d  : %4d\r\n",lngSizeStep[j],lngSizeStep[j + 1],lngBlobNum[j]);
				m_result = m_result + cStr;
			}
			
		}
	}
	free((long *)lngSizeStep);
	free((long *)lngBlobNum);

	UpdateData( FALSE );

}
